"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var zxel_exports = {};
__export(zxel_exports, {
  bunVersion: () => bunVersion,
  denoVersion: () => denoVersion,
  isBun: () => isBun,
  isDeno: () => isDeno,
  isNode: () => isNode,
  nodeVersion: () => nodeVersion
});
module.exports = __toCommonJS(zxel_exports);
var import_node_fs = __toESM(require("node:fs"), 1);
var import_node_util = require("node:util");
var emphasize = __toESM(require("emphasize"), 1);
var termKit = __toESM(require("terminal-kit"), 1);
var zx = __toESM(require("zx"), 1);
const args = process.argv.slice(2);
const version = "0.0.6";
const inspectOptions = {
  colors: true,
  depth: Infinity
};
const inspect = (value) => (0, import_node_util.inspect)(value, inspectOptions);
const isDev = process.env.NODE_ENV === "development";
const debugStream = isDev ? import_node_fs.default.createWriteStream("debug.txt") : {
  write() {
  },
  close() {
  }
};
const log = (str) => isDev ? debugStream.write(str) : null;
const run = async (code) => {
  return await eval(`(async function() { ${code} }).bind(global)()`);
};
function runCode(code2, timeout = 0) {
  return new Promise((resolve, reject) => {
    let timer;
    if (timeout) {
      timer = setTimeout(() => reject(new Error("Timeout")), timeout);
    }
    ;
    (async () => {
      const isExpression = !code2.match(
        /;|\n|const |for |if |let |var |while |try /g
      );
      try {
        const result = await run(isExpression ? `return ${code2}` : code2);
        timer && clearTimeout(timer);
        resolve(result);
      } catch (e) {
        if (!isExpression) {
          timer && clearTimeout(timer);
          reject(e);
          return;
        }
        run(code2).then(resolve).catch(reject).finally(() => timer && clearTimeout(timer));
      }
    })().catch(console.error);
  });
}
const userAgent = (() => {
  if (typeof window === "undefined")
    return void 0;
  const ua = window?.navigator?.userAgent ?? "";
  if (ua !== "") {
    return ua.includes("Deno") ? void 0 : ua;
  }
  return void 0;
})();
const getProcess = () => {
  try {
    return !userAgent && typeof process !== "undefined" ? process : {};
  } catch (err) {
    return {};
  }
};
const bunVersion = getProcess()?.versions?.bun;
const isBun = Boolean(bunVersion);
const denoVersion = (
  // eslint-disable-next-line no-undef
  typeof Deno !== "undefined" ? Deno?.version?.deno : void 0
);
const isDeno = Boolean(denoVersion) && !isBrowser;
const nodeVersion = isBun || isDeno ? void 0 : getProcess()?.versions?.node;
const isNode = Boolean(nodeVersion) && !isBun && !isDeno;
async function prepareRuntime() {
  Object.assign(globalThis, zx, {
    /**
     * Manually pipe key inputs because zx.$ does something to stdin that stops keypress
     * events after it exists.
     */
    $: async function(pieces, ...args2) {
      const p = zx.$(pieces, ...args2).nothrow().stdio("pipe", "pipe", "pipe").quiet();
      const result = await p;
      if (result.exitCode) {
        return new Error(result.stderr || `Exit code ${result.exitCode}`);
      }
      return result.stdout.trim();
    },
    $see: async function(pieces, ...args2) {
      const p = zx.$(pieces, ...args2).nothrow().stdio("pipe", "pipe", "pipe");
      const result = await p;
      if (result.exitCode) {
        return new Error(result.stderr || `Exit code ${result.exitCode}`);
      }
      return result.toString().trim();
    },
    inspect,
    log: console.log,
    globDir: (pattern, options = {}) => zx.glob(pattern, {
      onlyDirectories: true,
      ...options
    }),
    exit: () => process.exit(),
    ...isBun ? Object.assign(
      {
        // Override zx.fetch with Bun native
        fetch: globalThis.fetch
      },
      await import("bun:sqlite")
    ) : {}
  });
  globalThis.$``;
}
const emph = emphasize.createEmphasize(emphasize.common);
log("\n");
process.on("beforeExit", () => {
  debugStream.close();
});
let term = globalThis.term;
if (term) {
  term.removeAllListeners();
} else {
  term = globalThis.term = termKit.terminal;
}
let buffer = "";
let startPosition = { x: 0, y: 0 };
let endPosition = { x: 0, y: 0 };
let bufferCursorIndex = 0;
let prompt = "";
let promptLength = 0;
const history = [];
let historyCursor = 0;
function setPrompt(str) {
  prompt = str;
  promptLength = termKit.stringWidth(str);
}
async function showPrompt() {
  Object.assign(startPosition, await term.getCursorLocation());
  log("Prompt start: " + JSON.stringify(startPosition) + "\n");
  term(prompt);
  Object.assign(endPosition, {
    x: startPosition.x + promptLength,
    y: startPosition.y
  });
  bufferCursorIndex = 0;
}
function calculateCursorPosition(index = bufferCursorIndex, relative = false) {
  index += promptLength;
  const row = Math.floor(index / term.width);
  let col = index - term.width * row;
  if (col < 0)
    col = 0;
  let x = col;
  let y = row;
  if (!relative) {
    x += startPosition.x;
    y += startPosition.y;
  }
  const cursor = {
    x,
    y
  };
  return cursor;
}
async function updateLine() {
  const output = buffer ? emph.highlight("js", buffer).value : "";
  term.eraseArea(
    1,
    // startPosition.x,
    startPosition.y,
    term.width,
    endPosition.y - startPosition.y + 1
  );
  term.hideCursor(true);
  term.moveTo(startPosition.x, startPosition.y);
  term(`\r${prompt}${output}`);
  const relativeEndPosition = calculateCursorPosition(buffer.length, true);
  const endRow = startPosition.y + relativeEndPosition.y;
  if (endRow >= term.height) {
    const diff = term.height - endRow;
    log(`Scroll: ${diff}
`);
    startPosition.y += diff;
    if (diff === -1 && relativeEndPosition.x === 0) {
      term("\n");
    }
  }
  Object.assign(endPosition, await term.getCursorLocation());
  log(
    "DRAW " + JSON.stringify(startPosition) + " ~ " + JSON.stringify(endPosition) + "\n"
  );
  const cursor = calculateCursorPosition();
  term.moveTo(cursor.x, cursor.y);
  term.hideCursor(false);
  log(
    "CURSOR " + JSON.stringify(calculateCursorPosition()) + " = " + JSON.stringify(bufferCursorIndex) + "\n"
  );
}
function clearScreen() {
  term.clear();
  Object.assign(startPosition, { x: 1, y: 1 });
  updateLine();
}
term.on("key", async (name, matches, data) => {
  if (data.isCharacter) {
    term(name);
    buffer = buffer.slice(0, bufferCursorIndex) + name + buffer.slice(bufferCursorIndex);
    bufferCursorIndex++;
    updateLine();
    return;
  }
  switch (name) {
    case "CTRL_C":
      term("\n");
      process.exit();
      break;
    case "BACKSPACE":
      if (buffer[bufferCursorIndex - 1]) {
        buffer = buffer.slice(0, bufferCursorIndex - 1) + buffer.slice(bufferCursorIndex);
        bufferCursorIndex--;
        updateLine();
      }
      break;
    case "DELETE":
      if (buffer[bufferCursorIndex]) {
        buffer = buffer.slice(0, bufferCursorIndex) + buffer.slice(bufferCursorIndex + 1);
        updateLine();
      }
      break;
    case "ENTER":
      {
        const cursor = calculateCursorPosition(buffer.length);
        term.moveTo(cursor.x, cursor.y);
      }
      term("\n");
      if (buffer === "help") {
        console.log(`Available commands

clear - Clear screen
exit - Exit
help - Show this help screen
version - Show version

Documentation: https://github.com/eliot-akira/zxel`);
        buffer = "";
        showPrompt();
        return;
      } else if (buffer === "clear") {
        buffer = "";
        bufferCursorIndex = 0;
        clearScreen();
        return;
      } else if (buffer === "exit") {
        process.exit();
        return;
      } else if (buffer === "version") {
        console.log("Version", version);
        return;
      }
      history.push(buffer);
      history.splice(100, history.length - 100);
      historyCursor = history.length;
      try {
        const result = await runCode(buffer);
        if (result) {
          console.log(typeof result === "object" ? inspect(result) : result);
        }
      } catch (e) {
        term.red(e.message + "\n");
      }
      buffer = "";
      showPrompt();
      break;
    case "UP":
      if (historyCursor > 0 && history[historyCursor - 1]) {
        buffer = history[historyCursor - 1];
        historyCursor--;
        bufferCursorIndex = buffer.length;
        updateLine();
      }
      break;
    case "DOWN":
      if (history.length === 0)
        return;
      if (history[historyCursor + 1]) {
        buffer = history[historyCursor + 1];
        historyCursor++;
        bufferCursorIndex = buffer.length;
      } else {
        historyCursor = history.length;
        buffer = "";
        bufferCursorIndex = 0;
      }
      updateLine();
      break;
    case "LEFT":
      if (bufferCursorIndex > 0) {
        bufferCursorIndex--;
        const cursor = calculateCursorPosition();
        term.moveTo(cursor.x, cursor.y);
      }
      break;
    case "RIGHT":
      if (bufferCursorIndex < buffer.length) {
        bufferCursorIndex++;
        const cursor = calculateCursorPosition();
        term.moveTo(cursor.x, cursor.y);
      }
      break;
    case "CTRL_LEFT":
    case "CTRL_B":
      if (bufferCursorIndex > 0) {
        const match = /([\w_-]+|\s+|[^A-Za-z0-9_\s]+)$/.exec(
          buffer.slice(0, bufferCursorIndex)
          // Match to the left only
        );
        if (match) {
          bufferCursorIndex = match.index;
        } else {
          bufferCursorIndex--;
        }
        const cursor = calculateCursorPosition();
        term.moveTo(cursor.x, cursor.y);
      }
      break;
    case "CTRL_RIGHT":
    case "CTRL_F":
      {
        let currentIndex = bufferCursorIndex;
        const match = /^([\w_-]+|\s+|[^A-Za-z0-9_\s]+)/d.exec(
          buffer.slice(bufferCursorIndex)
          // Match to the right only
        );
        if (match && match.indices && match.indices[0]) {
          const [start, end] = match.indices[0];
          bufferCursorIndex = bufferCursorIndex + end;
        } else {
          if (bufferCursorIndex < buffer.length) {
            bufferCursorIndex++;
          }
        }
        if (currentIndex !== bufferCursorIndex) {
          const cursor = calculateCursorPosition();
          term.moveTo(cursor.x, cursor.y);
        }
      }
      break;
    case "CTRL_A":
    case "HOME":
      {
        bufferCursorIndex = 0;
        const cursor = calculateCursorPosition();
        term.moveTo(cursor.x, cursor.y);
      }
      break;
    case "CTRL_E":
    case "END":
      {
        bufferCursorIndex = buffer.length;
        const cursor = calculateCursorPosition();
        term.moveTo(cursor.x, cursor.y);
      }
      break;
    case "CTRL_L":
    case "CTRL_R":
      clearScreen();
      break;
    default:
      break;
  }
});
console.log(`\x1B[1;32mzxel\x1B[1;37m - Interactive JavaScript runtime shell
\x1B[2;37mEnter code to run, "help" to see commands, or "exit"\x1B[0m`);
prepareRuntime().then(() => {
  term.grabInput(true);
  setPrompt("\x1B[033\x1B[34mzx\x1B[30m>\x1B[00m ");
  showPrompt();
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  bunVersion,
  denoVersion,
  isBun,
  isDeno,
  isNode,
  nodeVersion
});
